package net.lecnam.info.remotelist;

import java.io.Serializable;

sealed interface Answer<E> extends Serializable {
	record Size<E>(int size) implements Answer<E> {}
	record Value<E>(E value) implements Answer<E> {}
	record OldValue<E>(E value) implements Answer<E> {}
	record Done<E>() implements Answer<E> {}
}