package net.lecnam.info.remotelist;

import java.util.List;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.LinkedBlockingQueue;
import net.lecnam.info.channel.LocalObjectReader;
import net.lecnam.info.channel.LocalObjectWriter;
import net.lecnam.info.channel.ObjectReader;
import net.lecnam.info.channel.ObjectWriter;

public class Main {

	public static void main(String[] args) {

		BlockingQueue<Request<String>> bqcs = new LinkedBlockingQueue<>();
		BlockingQueue<Answer<String>> bqsc = new LinkedBlockingQueue<>();

		List<String> l = List.of("a1", "a3", "a5", "a7", "a9", "a11", "a13", "a17");

		ObjectWriter<Answer<String>> outs = new LocalObjectWriter<>(bqsc);
		ObjectReader<Request<String>> ins = new LocalObjectReader<>(bqcs);
				
		Server<String> server = new Server<>(ins, outs, l);
		
		ObjectWriter<Request<String>> outc = new LocalObjectWriter<>(bqcs);
		ObjectReader<Answer<String>> inc = new LocalObjectReader<>(bqsc);
		
		Client client = new Client(inc, outc);

		Thread tc = new Thread(client);
		Thread ts = new Thread(server);

		tc.start();
		ts.start();

	}
}
